# `devtool` Quick Reference

The `devtool` command-line tool provides a number of features that help you build, test, and package software. This command is available alongside the `bitbake` command. Additionally, the `devtool` command is a key part of the extensible SDK.

This chapter provides a Quick Reference for the `devtool` command. For more information on how to apply the command when using the extensible SDK, see the "Using the Extensible SDK" section in the Yocto Project Software Development Kit (SDK) Developer's Guide.

## Getting Help

The `devtool` command line is organized similarly to Git in that it has a number of sub-commands for each function. You can run `devtool --help` to see all the commands:

         $ devtool --help
         usage: devtool [--basepath BASEPATH] [--bbpath BBPATH] [-d] [-q]
                        [--color COLOR] [-h]
                        <subcommand> ...

         OpenEmbedded development tool

         options:
           --basepath BASEPATH  Base directory of SDK / build directory
           --bbpath BBPATH      Explicitly specify the BBPATH, rather than getting it
                                from the metadata
           -d, --debug          Enable debug output
           -q, --quiet          Print only errors
           --color COLOR        Colorize output (where COLOR is auto, always, never)
           -h, --help           show this help message and exit

         subcommands:
           Beginning work on a recipe:
             add                  Add a new recipe
             modify               Modify the source for an existing recipe
             upgrade              Upgrade an existing recipe
           Getting information:
             status               Show workspace status
             search               Search available recipes
           Working on a recipe in the workspace:
             edit-recipe          Edit a recipe file in your workspace
             configure-help       Get help on configure script options
             build                Build a recipe
             update-recipe        Apply changes from external source tree to recipe
             reset                Remove a recipe from your workspace
             finish               Finish working on a recipe in your workspace
           Testing changes on target:
             deploy-target        Deploy recipe output files to live target machine
             undeploy-target      Undeploy recipe output files in live target machine
             build-image          Build image including workspace recipe packages
           Advanced:
             create-workspace     Set up workspace in an alternative location
             extract              Extract the source for an existing recipe
             sync                 Synchronize the source tree for an existing recipe
         Use devtool <subcommand> --help to get help on a specific command

As directed in the general help output, you can get more syntax on a specific command by providing the command name and using `--help`:

         $ devtool add --help
         usage: devtool add [-h] [--same-dir | --no-same-dir] [--fetch URI]
                            [--version VERSION] [--no-git] [--autorev] [--binary]
                            [--also-native] [--src-subdir SUBDIR]
                            [recipename] [srctree] [fetchuri]

         Adds a new recipe to the workspace to build a specified source tree. Can
         optionally fetch a remote URI and unpack it to create the source tree.

         arguments:
           recipename            Name for new recipe to add (just name - no version,
                                 path or extension). If not specified, will attempt to
                                 auto-detect it.
           srctree               Path to external source tree. If not specified, a
                                 subdirectory of
                                 /home/scottrif/poky/build/workspace/sources will be
                                 used.
           fetchuri              Fetch the specified URI and extract it to create the
                                 source tree

         options:
           -h, --help            show this help message and exit
           --same-dir, -s        Build in same directory as source
           --no-same-dir         Force build in a separate build directory
           --fetch URI, -f URI   Fetch the specified URI and extract it to create the
                                 source tree (deprecated - pass as positional argument
                                 instead)
           --version VERSION, -V VERSION
                                 Version to use within recipe (PV)
           --no-git, -g          If fetching source, do not set up source tree as a git
                                 repository
           --autorev, -a         When fetching from a git repository, set SRCREV in the
                                 recipe to a floating revision instead of fixed
           --binary, -b          Treat the source tree as something that should be
                                 installed verbatim (no compilation, same directory
                                 structure). Useful with binary packages e.g. RPMs.
           --also-native         Also add native variant (i.e. support building recipe
                                 for the build host as well as the target machine)
           --src-subdir SUBDIR   Specify subdirectory within source tree to use

## The Workspace Layer Structure

`devtool` uses a "Workspace" layer in which to accomplish builds. This layer is not specific to any single `devtool` command but is rather a common working area used across the tool.

The following figure shows the workspace structure:

         attic - A directory created if devtool believes it preserve
                 anything when you run "devtool reset".  For example, if you
                 run "devtool add", make changes to the recipe, and then
                 run "devtool reset", devtool takes notice that the file has
                 been changed and moves it into the attic should you still
                 want the recipe.

         README - Provides information on what is in workspace layer and how to
                  manage it.

         .devtool_md5 - A checksum file used by devtool.

         appends - A directory that contains *.bbappend files, which point to
                   external source.

         conf - A configuration directory that contains the layer.conf file.

         recipes - A directory containing recipes.  This directory contains a
                   folder for each directory added whose name matches that of the
                   added recipe.  devtool places the recipe.bb file
                   within that sub-directory.

         sources - A directory containing a working copy of the source files used
                   when building the recipe.  This is the default directory used
                   as the location of the source tree when you do not provide a
                   source tree path.  This directory contains a folder for each
                   set of source files matched to a corresponding recipe.

## Adding a New Recipe to the Workspace Layer

Use the `devtool add` command to add a new recipe to the workspace layer. The recipe you add should not exist - `devtool` creates it for you. The source files the recipe uses should exist in an external area.

The following example creates and adds a new recipe named `jackson` to a workspace layer the tool creates. The source code built by the recipes resides in `/home/scottrif/sources/jackson`:

         $ devtool add jackson /home/scottrif/sources/jackson

If you add a recipe and the workspace layer does not exist, the command creates the layer and populates it as described in "The Workspace Layer Structure" section.

Running `devtool add` when the workspace layer exists causes the tool to add the recipe, append files, and source files into the existing workspace layer. The `.bbappend` file is created to point to the external source tree.

## Extracting the Source for an Existing Recipe

Use the `devtool extract` command to extract the source for an existing recipe. When you use this command, you must supply the root name of the recipe (i.e. no version, paths, or extensions), and you must supply the directory to which you want the source extracted.

Additional command options let you control the name of a development branch into which you can checkout the source and whether or not to keep a temporary directory, which is useful for debugging.

## Synchronizing a Recipe's Extracted Source Tree

Use the `devtool sync` command to synchronize a previously extracted source tree for an existing recipe. When you use this command, you must supply the root name of the recipe (i.e. no version, paths, or extensions), and you must supply the directory to which you want the source extracted.

Additional command options let you control the name of a development branch into which you can checkout the source and whether or not to keep a temporary directory, which is useful for debugging.

## Modifying an Existing Recipe

Use the `devtool modify` command to begin modifying the source of an existing recipe. This command is very similar to the `add` command except that it does not physically create the recipe in the workspace layer because the recipe already exists in an another layer.

The `devtool modify` command extracts the source for a recipe, sets it up as a Git repository if the source had not already been fetched from Git, checks out a branch for development, and applies any patches from the recipe as commits on top. You can use the following command to checkout the source files:

         $ devtool modify recipe

Using the above command form, `devtool` uses the existing recipe's `SRC_URI` statement to locate the upstream source, extracts the source into the default sources location in the workspace. The default development branch used is "devtool".

## Edit an Existing Recipe

Use the `devtool edit-recipe` command to run the default editor, which is identified using the `EDITOR` variable, on the specified recipe.

When you use the `devtool edit-recipe` command, you must supply the root name of the recipe (i.e. no version, paths, or extensions). Also, the recipe file itself must reside in the workspace as a result of the `devtool add` or `devtool upgrade` commands. However, you can override that requirement by using the "-a" or "--any-recipe" option. Using either of these options allows you to edit any recipe regardless of its location.

## Updating a Recipe

Use the `devtool update-recipe` command to update your recipe with patches that reflect changes you make to the source files. For example, if you know you are going to work on some code, you could first use the `devtool modify` command to extract the code and set up the workspace. After which, you could modify, compile, and test the code.

When you are satisfied with the results and you have committed your changes to the Git repository, you can then run the `devtool update-recipe` to create the patches and update the recipe:

         $ devtool update-recipe recipe

If you run the `devtool update-recipe` without committing your changes, the command ignores the changes.

Often, you might want to apply customizations made to your software in your own layer rather than apply them to the original recipe. If so, you can use the `-a` or `--append` option with the `devtool update-recipe` command. These options allow you to specify the layer into which to write an append file:

         $ devtool update-recipe recipe -a base-layer-directory

The `*.bbappend` file is created at the appropriate path within the specified layer directory, which may or may not be in your `bblayers.conf` file. If an append file already exists, the command updates it appropriately.

## Upgrading a Recipe

Use the `devtool upgrade` command to upgrade an existing recipe to a new upstream version. The command puts the upgraded recipe file into the workspace along with any associated files, and extracts the source tree to a specified location should patches need rebased or added to as a result of the upgrade.

When you use the `devtool upgrade` command, you must supply the root name of the recipe (i.e. no version, paths, or extensions), and you must supply the directory to which you want the source extracted. Additional command options let you control things such as the version number to which you want to upgrade (i.e. the `PV`), the source revision to which you want to upgrade (i.e. the `SRCREV`, whether or not to apply patches, and so forth.

## Resetting a Recipe

Use the `devtool reset` command to remove a recipe and its configuration (e.g. the corresponding `.bbappend` file) from the workspace layer. Realize that this command deletes the recipe and the append file. The command does not physically move them for you. Consequently, you must be sure to physically relocate your updated recipe and the append file outside of the workspace layer before running the `devtool reset` command.

If the `devtool reset` command detects that the recipe or the append files have been modified, the command preserves the modified files in a separate "attic" subdirectory under the workspace layer.

Here is an example that resets the workspace directory that contains the `mtr` recipe:

         $ devtool reset mtr
         NOTE: Cleaning sysroot for recipe mtr...
         NOTE: Leaving source tree /home/scottrif/poky/build/workspace/sources/mtr as-is; if you no
            longer need it then please delete it manually
         $

## Building Your Recipe

Use the `devtool build` command to cause the OpenEmbedded build system to build your recipe. The `devtool build` command is equivalent to `bitbake -c populate_sysroot`.

When you use the `devtool build` command, you must supply the root name of the recipe (i.e. no version, paths, or extensions). You can use either the "-s" or the "--disable-parallel-make" option to disable parallel makes during the build. Here is an example:

         $ devtool build recipe

## Building Your Image

Use the `devtool build-image` command to build an image, extending it to include packages from recipes in the workspace. Using this command is useful when you want an image that ready for immediate deployment onto a device for testing. For proper integration into a final image, you need to edit your custom image recipe appropriately.

When you use the `devtool build-image` command, you must supply the name of the image. This command has no command line options:

         $ devtool build-image image

## Deploying Your Software on the Target Machine

Use the `devtool deploy-target` command to deploy the recipe's build output to the live target machine:

         $ devtool deploy-target recipe target

The target is the address of the target machine, which must be running an SSH server (i.e. `user@hostname[:destdir]`).

This command deploys all files installed during the `do_install` task. Furthermore, you do not need to have package management enabled within the target machine. If you do, the package manager is bypassed.

### Notes

The `deploy-target` functionality is for development only. You should never use it to update an image that will be used in production.

## Removing Your Software from the Target Machine

Use the `devtool undeploy-target` command to remove deployed build output from the target machine. For the `devtool undeploy-target` command to work, you must have previously used the `devtool deploy-target` command.

         $ devtool undeploy-target recipe target

The target is the address of the target machine, which must be running an SSH server (i.e. `user@hostname`).

## Creating the Workspace Layer in an Alternative Location

Use the `devtool create-workspace` command to create a new workspace layer in your Build Directory. When you create a new workspace layer, it is populated with the `README` file and the `conf` directory only.

The following example creates a new workspace layer in your current working and by default names the workspace layer "workspace":

         $ devtool create-workspace

You can create a workspace layer anywhere by supplying a pathname with the command. The following command creates a new workspace layer named "new-workspace":

         $ devtool create-workspace /home/scottrif/new-workspace

## Get the Status of the Recipes in Your Workspace

Use the `devtool status` command to list the recipes currently in your workspace. Information includes the paths to their respective external source trees.

The `devtool status` command has no command-line options:

         $ devtool status

Following is sample output after using `devtool add` to create and add the `mtr_0.86.bb` recipe to the `workspace` directory:

         $ devtool status
         mtr: /home/scottrif/poky/build/workspace/sources/mtr (/home/scottrif/poky/build/workspace/recipes/mtr/mtr_0.86.bb)
         $

## Search for Available Target Recipes

Use the `devtool search` command to search for available target recipes. The command matches the recipe name, package name, description, and installed files. The command displays the recipe name as a result of a match.

When you use the `devtool search` command, you must supply a keyword. The command uses the keyword when searching for a match.